/*******************************************************************************
 * FoxSocialUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSocialUI extends Object within FoxMenuUI
    native(UI)
    config(UI);

struct native PlayerSearchData
{
    var string sPlayerName;

    structdefaultproperties
    {
        sPlayerName=""
    }
};

struct native SearchTabInfo
{
    var string ListPath;
    var array<PlayerSearchData> SearchList;
    var int ClickedIndex;
    var FoxUIModalDialogWidget ModalDialog;

    structdefaultproperties
    {
        ListPath=""
        SearchList=none
        ClickedIndex=0
        ModalDialog=none
    }
};

struct native SendMailInfo
{
    var bool bChooseMailItems;
    var string To;
    var string Subject;
    var string Text;
    var array<InventoryMetaData> Items;

    structdefaultproperties
    {
        bChooseMailItems=false
        To=""
        Subject=""
        Text=""
        Items=none
    }
};

var private transient bool bSocialIsInitialized;
var private transient bool bProfileDirty;
var bool bRemoteSelectInitial;
var GFxObject ProfileCategory;
var GFxObject EmblemCategory;
var GFxObject TitleCategory;
var GFxObject LeaderboardCategory;
var GFxObject FindPlayerCategory;
var GFxObject FriendsCategory;
var GFxObject PartyCategory;
var GFxObject ClanCategory;
var GFxObject MailCategory;
var GFxObject MartCategory;
var GFxObject InventoryCategory;
var GFxObject InspectCategory;
var GFxObject NewsCategory;
var GFxObject SupportCategory;
var GFxObject PrestigeCategory;
var() const config string OwnedItemColor;
var() const config string ExpiredItemColor;
var() const config string EmptyStackItemColor;
var transient FoxSocialUICategoryBase CurrentSocialCategory;
var const config string ProfileTutorial;
var const config string FriendsTutorial;
var const config string PartyTutorial;
var const config string ClanTutorial;
var const config string MailTutorial;
var const config string InventoryTutorial;
var const config string NodesTutorial;
var const config string SupportTutorial;
var SearchTabInfo SearchTabInfoStruct;
var SendMailInfo PendingSendMailInfo;
var array<GFxObject> SocialTabsArray;
var int CurrentSocialTabIndex;
var delegate<CurrentDisplayFunc> __CurrentDisplayFunc__Delegate;

delegate CurrentDisplayFunc(string ChangeTag)
{
    //return;    
}

function Initialize()
{
    Outer.Outer.Chat.RefreshButtons();
    //return;    
}

function ui_createSocialCategories()
{
    local FoxPRI PRI;
    local int ClanItem;

    PRI = FoxPRI(Outer.Outer.PCOwner.PlayerReplicationInfo);
    ClanItem = 74;
    // End:0xEB
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        as_AddSocialLeftPrompt("img://" $ Outer.Outer.GetImageIconStringFromButtonName("XboxTypeS_LeftShoulder", false));
    }
    ProfileCategory = Outer.Outer.GetVariableObject(ui_addSocialCategory("ProfileLabel", "Profiletooltip", "ei_SocialButtonClicked", "profile", "changeSocialCat", "img://Menu.profile2Icon", "profile"));
    FriendsCategory = Outer.Outer.GetVariableObject(ui_addSocialCategory("FriendsLabel", "FriendsTooltip", "ei_SocialButtonClicked", "friends", "changeSocialCat", "img://Menu.friendsIcon", "friends"));
    // End:0x333
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        PartyCategory = Outer.Outer.GetVariableObject(ui_addSocialCategory("PartyLabel", "PartyTooltip", "ei_SocialButtonClicked", "party", "changeSocialCat", "img://Menu.partyIcon", "party"));
    }
    // End:0x4A1
    if((class'FoxUnlockInfo'.static.GetItemUnlockedStateFromID(ClanItem, PRI,,, true) != 6) && Outer.Outer.PCOwner.OnlineSub.PlayerInterface.GetLoginStatus(0) > 1)
    {
        ClanCategory = Outer.Outer.GetVariableObject(ui_addSocialCategory("ClanLabel", "ClanTooltip", "ei_SocialButtonClicked", "clan", "changeSocialCat", "img://Menu.clanIcon", "clan"));
    }
    PrestigeCategory = Outer.Outer.GetVariableObject(ui_addSocialCategory("prestigeLabel", "prestigeTooltip", "ei_SocialButtonClicked", "prestige", "changeSocialCat", "img://UI_Icons.t_prestige_icon", "prestige"));
    // End:0x5EC
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        as_AddSocialRightPrompt("img://" $ Outer.Outer.GetImageIconStringFromButtonName("XboxTypeS_RightShoulder", false));
    }
    SocialTabsArray.AddItem(ProfileCategory);
    SocialTabsArray.AddItem(FriendsCategory);
    // End:0x63D
    if(PartyCategory != none)
    {
        SocialTabsArray.AddItem(PartyCategory);
    }
    // End:0x662
    if(ClanCategory != none)
    {
        SocialTabsArray.AddItem(ClanCategory);
    }
    SocialTabsArray.AddItem(PrestigeCategory);
    CurrentSocialTabIndex = 0;
    Outer.Outer.Advance(0.0);
    socialUpdateUnreadMail(Outer.PlayerWidgetLastUnreadMailNum);
    //return;    
}

function socialUpdateClanTag(string PlayersClanTag)
{
    local string LocLabel, NewLabel;

    LocLabel = SocialLocalize("ClanLabel");
    // End:0xC6
    if(ClanCategory != none)
    {
        // End:0x96
        if(PlayersClanTag != "")
        {
            NewLabel = (LocLabel @ " | ") @ PlayersClanTag;
            ClanCategory.SetString("label", NewLabel);
        }
        // End:0xC6
        else
        {
            ClanCategory.SetString("label", LocLabel);
        }
    }
    //return;    
}

event socialUpdateUnreadMail(int UnreadMailCount)
{
    local string LocLabel, NewLabel;

    LocLabel = SocialLocalize("MailLabel");
    // End:0xCB
    if(MailCategory != none)
    {
        // End:0x9B
        if(UnreadMailCount != 0)
        {
            NewLabel = ((LocLabel @ " [") @ string(UnreadMailCount)) @ "]";
            MailCategory.SetString("label", NewLabel);
        }
        // End:0xCB
        else
        {
            MailCategory.SetString("label", LocLabel);
        }
    }
    //return;    
}

event socialUpdatePartyOnline(int OnlinePartyCount)
{
    //return;    
}

function Cleanup()
{
    Outer.Outer.CancelTask(class'FoxPurchaseItemUI');
    Outer.Outer.CancelTask(class'FoxActivateItemUI');
    Outer.Outer.CancelTask(class'FoxRenewItemUI');
    Outer.Outer.CancelTask(class'FoxDestroyItemUI');
    Outer.Outer.CancelTask(class'FoxRefreshCacheUI');
    ClearDelegates();
    ProfileCategory.RemoveMovieClip();
    FriendsCategory.RemoveMovieClip();
    // End:0x1A7
    if(PartyCategory != none)
    {
        PartyCategory.RemoveMovieClip();
    }
    // End:0x1D5
    if(ClanCategory != none)
    {
        ClanCategory.RemoveMovieClip();
    }
    PrestigeCategory.RemoveMovieClip();
    ProfileCategory = none;
    FriendsCategory = none;
    PartyCategory = none;
    ClanCategory = none;
    PrestigeCategory = none;
    // End:0x259
    if(CurrentSocialCategory != none)
    {
        CurrentSocialCategory.NotifyClosing();
    }
    // End:0x2C9
    if(bProfileDirty)
    {
        Outer.Outer.PCOwner.SaveProfile("Social Tab Profile Dirty");
    }
    Outer.Outer.as_SetBoolParam(false, "bSocialOpen");
    bProfileDirty = false;
    //return;    
}

function TryCallDisplayFunc(string ChangeTag)
{
    // End:0x2B
    if(__CurrentDisplayFunc__Delegate != none)
    {
        CurrentDisplayFunc(ChangeTag);
    }
    //return;    
}

function MarkProfileDirty()
{
    bProfileDirty = true;
    //return;    
}

function ClearDelegates()
{
    //return;    
}

function string SocialLocalize(string Key)
{
    return Outer.LocalizeMenuString(Key, "Social");
    //return ReturnValue;    
}

function string ui_addSocialCategory(string BtnLabel, string btnTooltip, string extClickInterfaceFunc, optional string ExtInterfaceArg, optional string transition, optional string Icon, optional string ButtonID)
{
    local string ButtonPath;
    local GFxObject ButtonObject;

    ButtonPath = as_addSocialCategory(BtnLabel, btnTooltip, extClickInterfaceFunc, ExtInterfaceArg, transition, Icon);
    ButtonObject = Outer.Outer.GetVariableObject(ButtonPath);
    // End:0xD8
    if(ButtonObject != none)
    {
        ButtonObject.SetString("uniqueID", ButtonID);
    }
    return ButtonPath;
    //return ReturnValue;    
}

event string as_addSocialCategory(string BtnLabel, string btnTooltip, string extClickInterfaceFunc, optional string ExtInterfaceArg, optional string transition, optional string Icon)
{
    BtnLabel = SocialLocalize(BtnLabel);
    btnTooltip = SocialLocalize(btnTooltip);
    return as_InternalAddSocialCategory(BtnLabel, btnTooltip, extClickInterfaceFunc, ExtInterfaceArg, transition, Icon);
    //return ReturnValue;    
}

function string as_InternalAddSocialCategory(string BtnLabel, string btnTooltip, string extClickInterfaceFunc, optional string ExtInterfaceArg, optional string transition, optional string Icon)
{
    return Outer.Outer.ActionScriptString("_root.addSocialCategory2_0");
    //return ReturnValue;    
}

function as_TransitionSocialMenu()
{
    Outer.Outer.ActionScriptVoid("_root._root.playerWidgetName.transitionSocialMenu");
    //return;    
}

function ei_SocialButtonClicked(string Arg, optional int SubIndex, optional bool bForceRedraw)
{
    local class<FoxSocialUICategoryBase> CategoryClass;

    bForceRedraw = false;
    __CurrentDisplayFunc__Delegate = None;
    // End:0x4F
    if(Arg ~= "miniMart")
    {
        CategoryClass = class'FoxSocialCategoryMiniMart';
    }
    // End:0x263
    else
    {
        // End:0x79
        if(Arg ~= "clan")
        {
            CategoryClass = class'FoxSocialCategoryClan';
        }
        // End:0x263
        else
        {
            // End:0xA3
            if(Arg ~= "Mail")
            {
                CategoryClass = class'FoxSocialCategoryMail';
            }
            // End:0x263
            else
            {
                // End:0xD2
                if(Arg ~= "inventory")
                {
                    CategoryClass = class'FoxSocialCategoryInventory';
                }
                // End:0x263
                else
                {
                    // End:0xFF
                    if(Arg ~= "friends")
                    {
                        CategoryClass = class'FoxSocialCategoryFriends';
                    }
                    // End:0x263
                    else
                    {
                        // End:0x12C
                        if(Arg ~= "support")
                        {
                            CategoryClass = class'FoxSocialCategorySupport';
                        }
                        // End:0x263
                        else
                        {
                            // End:0x159
                            if(Arg ~= "profile")
                            {
                                CategoryClass = class'FoxSocialCategoryProfile';
                            }
                            // End:0x263
                            else
                            {
                                // End:0x185
                                if(Arg ~= "emblem")
                                {
                                    CategoryClass = class'FoxSocialCategoryEmblem';
                                }
                                // End:0x263
                                else
                                {
                                    // End:0x1B0
                                    if(Arg ~= "title")
                                    {
                                        CategoryClass = class'FoxSocialCategoryTitle';
                                    }
                                    // End:0x263
                                    else
                                    {
                                        // End:0x1DB
                                        if(Arg ~= "party")
                                        {
                                            CategoryClass = class'FoxSocialCategoryParty';
                                        }
                                        // End:0x263
                                        else
                                        {
                                            // End:0x20B
                                            if(Arg ~= "findplayer")
                                            {
                                                CategoryClass = class'FoxSocialCategoryFindPlayer';
                                            }
                                            // End:0x263
                                            else
                                            {
                                                // End:0x235
                                                if(Arg ~= "news")
                                                {
                                                    CategoryClass = class'FoxSocialCategoryNews';
                                                }
                                                // End:0x263
                                                else
                                                {
                                                    // End:0x263
                                                    if(Arg ~= "prestige")
                                                    {
                                                        CategoryClass = class'FoxSocialCategoryPrestige';
                                                    }
                                                    // End:0x263
                                                    else
                                                    {
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    // End:0x307
    if(CurrentSocialCategory == none)
    {
        CurrentSocialCategory = new (self) CategoryClass;
        CurrentSocialCategory.PendingCategoryIndex = SubIndex;
        Outer.Outer.PCOwner.SetTimer(0.010, false, 'SocialCategoryDelayInitialize', self);
    }
    // End:0x41E
    else
    {
        // End:0x3F6
        if((CategoryClass != CurrentSocialCategory.Class) || bForceRedraw)
        {
            CurrentSocialCategory.NotifyClosing();
            CurrentSocialCategory = new (self) CategoryClass;
            CurrentSocialCategory.PendingCategoryIndex = SubIndex;
            Outer.Outer.PCOwner.SetTimer(0.010, false, 'SocialCategoryDelayInitialize', self);
        }
        // End:0x41E
        else
        {
            CurrentSocialCategory.ui_selectSocialSubcategory(SubIndex);
        }
    }
    //return;    
}

function SocialCategoryDelayInitialize()
{
    CurrentSocialCategory.Initialize();
    //return;    
}

event RefreshSocialTab()
{
    Outer.Outer.as_transition("clearSocialContainer");
    Outer.Outer.Advance(0.0);
    //return;    
}

function RemoteSelectSocialCategory(GFxObject ButtonObject)
{
    Outer.Outer.HideContextMenuWidget(CurrentSocialCategory.ContextMenu);
    ButtonObject.ActionScriptVoid("remoteSelect");
    //return;    
}

function ei_createSocialTwitterButton()
{
    Outer.Outer.ui_RunCommandGroup("socialPostTransition");
    //return;    
}

function ui_addSocialTwitterButton(string ToolTip, string Message, string ButtonID)
{
    Outer.Outer.AddTwitterButton("_root.addSocialTwitterButton", "ei_SocialTwitterClicked", ToolTip, Message, ButtonID);
    //return;    
}

function ei_SocialTwitterClicked(string DefaultMessage)
{
    DefaultMessage = Outer.Outer.LocalizeTwitter(DefaultMessage);
    Outer.Outer.TrySendTweet(DefaultMessage);
    //return;    
}

event CycleSocialCategory(bool bIncrement)
{
    SocialTabsArray[CurrentSocialTabIndex].ActionScriptVoid("handleMouseRollOut");
    // End:0x81
    if(bIncrement)
    {
        // End:0x73
        if(CurrentSocialTabIndex == (SocialTabsArray.Length - 1))
        {
            CurrentSocialTabIndex = 0;
        }
        // End:0x7E
        else
        {
            ++ CurrentSocialTabIndex;
        }
    }
    // End:0xB5
    else
    {
        // End:0xAA
        if(CurrentSocialTabIndex == 0)
        {
            CurrentSocialTabIndex = SocialTabsArray.Length - 1;
        }
        // End:0xB5
        else
        {
            -- CurrentSocialTabIndex;
        }
    }
    RemoteSelectSocialCategory(SocialTabsArray[CurrentSocialTabIndex]);
    //return;    
}

function string as_AddSocialButtonContainer(string ContainerName, int XPos, int YPos, int Spacing, int MaxWidth, int MaxHeight, bool VertAlign, optional bool bInternalContainer)
{
    return Outer.Outer.ActionScriptString("_root.addSocialButtonContainer");
    //return ReturnValue;    
}

function as_AddSocialLeftPrompt(string PromptIcon)
{
    Outer.Outer.ActionScriptVoid("_root.setLeftSwitcherButton");
    //return;    
}

function as_AddSocialRightPrompt(string PromptIcon)
{
    Outer.Outer.ActionScriptVoid("_root.setRightSwitcherButton");
    //return;    
}

defaultproperties
{
    OwnedItemColor="0xfff2b2"
    ExpiredItemColor="0xff0000"
    EmptyStackItemColor="0x770000"
    ProfileTutorial="SocialProfileTutorial"
    FriendsTutorial="SocialFriendsTutorial"
    PartyTutorial="SocialPartyTutorial"
    ClanTutorial="SocialClanTutorial"
    MailTutorial="SocialMailTutorial"
    InventoryTutorial="SocialInventoryTutorial"
    NodesTutorial="SocialNodesTutorial"
    SupportTutorial="SocialSupportTutorial"
}